#include <bits/stdc++.h>
using namespace std;

const int MOD = 1000000007;

int main() {
    int R, C;
    cin >> R >> C;
    string W;
    cin >> W;
    vector<string> board(R);
    for (int r=0; r<R; ++r) cin >> board[r];

    vector< vector<int> > ways(R, vector<int>(C,0));
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (board[r][c] == W[0]) ways[r][c] = 1;

    for (int n=1; n<int(W.size()); ++n) {
        long long old_total = 0;
        for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) old_total += ways[r][c];
        old_total %= MOD;

        vector< vector<int> > newways(R, vector<int>(C,0));
        for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (board[r][c] == W[n]) {
            long long this_cell = old_total;
            this_cell -= ways[r][c];
            for (int dr=-1; dr<=1; ++dr) for (int dc=-1; dc<=1; ++dc) {
                if (dr == 0 && dc == 0) continue;
                for (int s=1; ; ++s) {
                    int nr = r + s*dr, nc = c + s*dc;
                    if (nr < 0 || nr >= R || nc < 0 || nc >= C) break;
                    this_cell -= ways[nr][nc];
                }
            }
            this_cell %= MOD;
            this_cell += MOD;
            this_cell %= MOD;
            newways[r][c] = this_cell;
        }
        ways = newways;
    }

    long long answer = 0;
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) answer += ways[r][c];
    answer %= MOD;
    cout << answer << endl;
}
