#include <bits/stdc++.h>
using namespace std;

const int MOD = 1000000007;

int main() {
    int R, C;
    cin >> R >> C;
    string W;
    cin >> W;
    vector<string> board(R);
    for (int r=0; r<R; ++r) cin >> board[r];

    vector< vector<long long> > ways(R, vector<long long>(C,0));
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (board[r][c] == W[0]) ways[r][c] = 1;

    for (int n=1; n<int(W.size()); ++n) {
        long long old_total = 0;
        vector<long long> columns(C,0), rows(R,0), plus(R+C-1,0), minus(R+C-1,0);
        for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) {
            old_total += ways[r][c];
            columns[c] += ways[r][c];
            rows[r] += ways[r][c];
            plus[r+c] += ways[r][c];
            minus[r+C-1-c] += ways[r][c];
        }

        vector< vector<long long> > newways(R, vector<long long>(C,0));
        for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) if (board[r][c] == W[n]) {
            long long this_cell = old_total;
            this_cell -= rows[r];
            this_cell -= columns[c];
            this_cell -= plus[r+c];
            this_cell -= minus[r+C-1-c];
            this_cell += 3*ways[r][c];
            this_cell %= MOD;
            this_cell += MOD;
            this_cell %= MOD;
            newways[r][c] = this_cell;
        }
        ways = newways;
    }

    long long answer = 0;
    for (int r=0; r<R; ++r) for (int c=0; c<C; ++c) answer += ways[r][c];
    answer %= MOD;
    cout << answer << endl;
}
